set seed 12345

matrix C = (1, .5 \ .5, 1)

capture program drop sim
program define sim, rclass
	drop _all
	drawnorm x1 x2 , n(1000) corr(C)
	gen byte y = uniform() < invlogit(0 + x1 + x2 )

	logit y x1 x2 
	return scalar b = _b[x1]
	test x1 = 1
	return scalar sig = r(p) < .05

	gen x2m = x2 if uniform() > invlogit(-3 + x1 + 2*y)

	logit y x1 x2m 
	return scalar bcc = _b[x1]
	test x1 = 1
	return scalar sigcc = r(p) < .05	

	impute x2m x1, gen(x2im)

	logit y x1 x2im 
	return scalar bim = _b[x1]
	test x1 = 1
	return scalar sigim = r(p) < .05

	tempfile imp
	ice y x1 x2m , saving(`imp') m(5)
	use `imp', clear
	logit y x1 x2m  if _mj == 1
	return scalar bsi = _b[x1]
	test x1 = 1
	return scalar sigsi = r(p) < .05

	micombine logit y x1 x2m 
	return scalar bmi = _b[x1]
	test x1 = 1
	return scalar sigmi = r(p) < .05
end
simulate b=r(b)     sig=r(sig)      ///
         bcc=r(bcc) sigcc=r(sigcc)  ///
         bim=r(bim) sigim=r(sigim)  ///
         bsi=r(bsi) sigsi=r(sigsi)  ///
         bmi=r(bmi) sigmi=r(sigmi), ///
         reps(10000) : sim

sum sig*

twoway kdensity b    || ///
       kdensity bcc  || ///
       kdensity bim  || ///
       kdensity bsi  || ///
       kdensity bmi,    ///
       xline(1)
