set seed 123456
set rmsg on
set more off
capture program drop sim
program define sim, rclass
	drop _all
	set obs 1000
	gen x = _n < 501

	gen y = 1 + .5*x + .7*invnorm(uniform())

	reg y x
	return scalar b = _b[x]
	test x = .5
	return scalar sig = r(p) < .05

	egen cat = cut(y), at(-2, 0, 1, 1.5, 2, 4)
	gen cat2 = cat
	recode cat2 (-2   = 0   ) ///
            	    ( 0   = 1   ) ///
      	            ( 1   = 1.5 ) ///
	            ( 1.5 = 2   ) ///
      	            ( 2   = .   )
	recode cat -2 = .

	local lns = ln(.7)
	intreg cat cat2 x,  from(_cons=1 x=.5 /lnsigma=`lns') 
	return scalar bi = _b[x]
	test x = .5
	return scalar sigi = r(p) < .05

	gen mid = cat
	recode mid  ( .   = -1   ) ///
      	            ( 0   =  0.5 ) ///
            	    ( 1   =  1.25) ///
	            ( 1.5 =  1.75) ///
      	            ( 2   =  3   )

	reg mid x 
	return scalar bm = _b[x]
	test x = .5
	return scalar sigm = r(p) < .05
end

simulate b=r(b)   sig=r(sig)    ///
         bi=r(bi) sigi=r(sigi)  ///
         bm=r(bm) sigm=r(sigm), ///
         reps(10000): sim

sum sig*

twoway kdensity b  || ///
       kdensity bi || ///
       kdensity bm , xline(.5)
       
cd "c:\mijn documenten\projecten\stata\sug\chicago08\"
graph save sim1.gph, replace

save normal.dta, replace

