set seed 12345

capture program drop sim
program define sim, rclass
	drop _all
	set obs 2000

	gen x = _n < 1001
	gen double u = uniform()
	gen y = 1 + .5*x + .7*sqrt(3)/_pi*ln(u/(1-u))
	reg y x
	return scalar b = _b[x]
	test x = .5
	return scalar sig = r(p) < .05

	egen cat1 = cut(y), at(-2, 0, 1, 1.5, 2, 4)
	gen cat2 = cat1
	recode cat2 (-2   = 0   ) ///
                    ( 0   = 1   ) ///
                    ( 1   = 1.5 ) ///
	            ( 1.5 = 2   ) ///
      	            ( 2   = .   )
	recode cat1 -2 = .

	intreg cat1 cat2 x
	return scalar bi = _b[x]
	test x = .5
	return scalar sigi = r(p) < .05

	gen mid = cat1
	recode mid  ( .   = -1   ) ///
                    ( 0   =  0.5 ) ///
                    ( 1   =  1.25) ///
	            ( 1.5 =  1.75) ///
                    ( 2   =  3   )
	
	reg mid x 
	return scalar bm = _b[x]
	test x = .5
	return scalar sigm = r(p) < .05
end

sim
return list

